#define __NQ_INTERNAL_SW__ // require _strnicmp in this file, so include internal nq things (also helper functions)

#include "NQ.h"

using namespace std;

extern void SimulateRemotePeer(const char *aIPAddressOtherPeer, UINT16 aPortOtherPeer, UINT16 aPort);
extern void SimulateLocalPeer(const char *aIPAddressOtherPeer, UINT16 aPortOtherPeer, UINT16 aPort);
/*
// win <-> linux
void LocalPeerStart()
{
	printf("Simulating (13 pi) local peer...\n");
	SimulateLocalPeer("141.34.30.177", 31900, 30900);
}

void RemotePeerStart()
{
	printf("Simulating (13 pi) remote peer...\n");
	SimulateRemotePeer("141.34.30.177", 31900, 30900);
}
*/

/*
// linux <-> solaris
void LocalPeerStart()
{
	printf("Simulating (13 pi (vs. aquila 012)) local peer...\n");
	SimulateLocalPeer("141.34.30.12", 31900, 32900);
}

void RemotePeerStart()
{
	printf("Simulating (13 pi (vs. aquila 012)) remote peer...\n");
	SimulateRemotePeer("141.34.30.12", 31900, 32900);
}
*/

/*
// linux <-> linux
void LocalPeerStart()
{
	printf("Simulating (13 pi (vs. pi2 015)) local peer...\n");
	SimulateLocalPeer("141.34.30.15", 31900, 32900);
}

void RemotePeerStart()
{
	printf("Simulating (15 pi2 (vs. pi 013)) remote peer...\n");
	SimulateRemotePeer("141.34.30.13", 32900, 31900);
}
*/

// nios <-> linux
void LocalPeerStart()
{
	printf("Simulating (13 pi (vs. nios2 109)) local peer...\n");
	printf("No local peer implemented.\nExiting...\n");
}

void RemotePeerStart()
{
	printf("Simulating (13 pi (vs. nios2 109)) remote peer...\n");
	SimulateRemotePeer("141.34.30.109", 32900, 31900);
}



int main(int argc, const char *argv[])
{
/*	printf("sz ui8=%d\n",sizeof(UINT8));
	printf("sz i8=%d\n",sizeof(INT8));

	printf("sz ui16=%d\n",sizeof(UINT16));
	printf("sz i16=%d\n",sizeof(INT16));

	printf("sz ui32=%d\n",sizeof(UINT32));
	printf("sz i32=%d\n",sizeof(INT32));
	printf("sz voidp=%d\n",sizeof(VOIDP));
*/	

	printf("Linux Main() starting up...");
	
	const char param[] = "/remote";

	if (argc > 1 && (strlen(argv[1]) == strlen(param)))
	{
		if (_strnicmp(argv[1], param, strlen(param)) == 0)
		{
			RemotePeerStart();
		}
	}
	else
	{
		LocalPeerStart();
	}

	return 0;
}
