#include "nq_system.h"
#include <assert.h>
#include "PlatformSW.h"
#include "NQDeclarations.h"
#include "NQLogging.h"

#if NQ_NO_LOGGING == 0

const char *gNQLoggingSrcFile = NULL;
int gNQLoggingType = 0;
int gNQLoggingLine= 0;


void exampleNQLoggingSetParameters(int aType, const char *aSrcFile, const int aLine)
{
	gNQLoggingSrcFile = aSrcFile;
	gNQLoggingType = aType;
	gNQLoggingLine = aLine;
}

void exampleNQLoggingHandler(const char *aFormatString,...)
{
	bool badLoggingType=true;

	FILE *filepointer = stderr;
	bool bCloseFileAtExit = false;

	switch (gNQLoggingType) 
	{
		case NQ_DBG_TYP:   
				fprintf(filepointer, "[NQ DEBUG %s:%d]: ",  gNQLoggingSrcFile, gNQLoggingLine); 
				break;
     
		default: 
				assert( badLoggingType == false );
				break;
	}

	va_list args;

    va_start( args, aFormatString);                // Write Data
    vfprintf( filepointer , aFormatString, args);
    va_end( args );

	if (bCloseFileAtExit == true)
	{
		fclose(filepointer);
	}
}

#endif
